###########################################################################
# $Id: JSHttpRequest.p,v 1.5 2006/04/21 17:38:58 misha Exp $
#
# class JSHttpRequest for working with 
#	Subsys_JsHttpRequest_Js <http://dklab.ru/lib/Subsys_JsHttpRequest/>
#	by Dmitry Koterov <http://forum.dklab.ru/users/DmitryKoterov/>
# based on some methods from here: <http://www.parser.ru/forum/?id=41408>
#	by Sergey M. 
# table for decode %u0430 & Co based on Eugene Sperance table
#
###########################################################################


@CLASS
JSHttpRequest


###########################################################################
@auto[]
$tDecode[^self._getDecodeTable[]]
#end @auto[]



###########################################################################
# for POST requests the data located in $request:body, for GET - in $request:query
# of cause we can check $env:REQUEST_METHOD also but in fact we don't need it
@decodeRequest[]
$result[^self.decodeText[^if(def $request:body){$request:body}{$request:query}]]
#end @decodeRequest[]



###########################################################################
@printResponse[sText;uVar]
$result[Subsys_JsHttpRequest_Js.dataReady(
	'^self.getId[]',
	'$sText',
	^self._object2js[$uVar]
)]
#end @printResponse[]



###########################################################################
@decodeText[sText][tField]
$result[^hash::create[]]

$tField[^sText.match[(?:^^|&|\?)([^^=]+)=([^^&]+)][gm]]

^tField.menu{
	^result.add[
		$.[^self._decode[$tField.1]][^self._decode[$tField.2]]
	]
}
#end @decodeText[]



###########################################################################
@getId[]
$result[$form:nameless]
$result[^result.match[\-xml^$][]{}]
#end @getId[]



###########################################################################
# carefull: for empty strings returned 'null'
@_object2js[uVar]
$result[]
^if(!(
	($uVar is "bool" && ($uVar && ^self._return[true] || ^self._return[false]))
	|| (!def $uVar && ^self._return[null])
	|| ($uVar is "string" && ^self._return[^_string2js[$uVar]])
	|| ($uVar is "int" && ^self._return[$uVar])
	|| ($uVar is "double" && ^self._return[$uVar])
	|| ($uVar is "table" && (($uVar && ^self._return[^self._table2js[$uVar]]) || ^self._return[null]))
	|| ($uVar is "hash" && (($uVar && ^self._return[^self._hash2js[$uVar]]) || ^self._return[null]))
	|| ($uVar is "date" && ^self._return[new Date(^uVar.unix-timestamp[]000)])
)){
	^self._return[null]
}
#end @_object2js[]



###########################################################################
@_return[sType]
$caller.result[$sType]
$result(1)
#end @_return[]



###########################################################################
@_decode[sText]
$result[^taint[^sText.replace[$tDecode]]]
#end @_decode[]



###########################################################################
@_string2js[sData]
$result['^taint[js][$sData]']
#end @_string2js[]



###########################################################################
@_hash2js[hData][bIsHashOfBool;sKey;oValue]
$bIsHashOfBool(1)
# check if our hash is hash of bool with only 'true' values
^hData.foreach[sKey;oValue]{
	^if($bIsHashOfBool && !($oValue is "bool" && $oValue)){
		$bIsHashOfBool(0)
	}
}

^if($bIsHashOfBool){
	^rem{ *** if hash of bool with 'true' values only - return ... *** }
	$result[[
		^hData.foreach[sKey;]{
			^self._string2js[$sKey]
		}[, ]
	]]
}{
	^rem{ *** in other case return associated array *** }
	$result[{
		^hData.foreach[sKey;oValue]{
			^self._string2js[$sKey]:
			^if($oValue is "bool" || $oValue is "int" || $oValue is "double"){
				^self._object2js($oValue)
			}{
				^self._object2js[$oValue]
			}
		}[, ]
	}]
}
#end @_hash2js[]



###########################################################################
@_table2js[tData][tKeys]
$tKeys[^tData.columns[]]
^if($tKeys){
	$result[[
		^tData.menu{
			{
				^tKeys.menu{
					^self._string2js[$tKeys.column]:^self._string2js[$tData.[$tKeys.column]]
				}[, ]
			}
		}[, ]
	]]
}{
	^rem{ *** nameless tables are deprecated, lah. *** }
	$result[null]
}
#end @_table2js[]



###########################################################################
@_getDecodeTable[]
$result[^table::create{from	to
%u2116	
%u0430	
%u0431	
%u0432	
%u0433	
%u0434	
%u0435	
%u0451	
%u0436	
%u0437	
%u0438	
%u0439	
%u043A	
%u043B	
%u043C	
%u043D	
%u043E	
%u043F	
%u0440	
%u0441	
%u0442	
%u0443	
%u0444	
%u0445	
%u0446	
%u0447	
%u0448	
%u0449	
%u044A	
%u044B	
%u044C	
%u044D	
%u044E	
%u044F	
%u0410	
%u0411	
%u0412	
%u0413	
%u0414	
%u0415	
%u0401	
%u0416	
%u0417	
%u0418	
%u0419	
%u041A	
%u041B	
%u041C	
%u041D	
%u041E	
%u041F	
%u0420	
%u0421	
%u0422	
%u0423	
%u0424	
%u0425	
%u0426	
%u0427	
%u0428	
%u0429	
%u042A	
%u042B	
%u042C	
%u042D	
%u042E	
%u042F	
%20	^#20
%21	!
%22	"
%23	#
%24	^$
%25	%
%26	&
%27	'
%28	(
%29	)
%2B	+
%2C	,
%3A	:
%3B	^;
%3C	<
%3D	=
%3E	>
%3F	?
%5B	^[
%5C	\
%5D	^]
%5E	^^
%60	`
%7B	^{
%7C	|
%7D	^}
%7E	~
}]
#end @_getDecodeTable[]



